var renderEngine;
var renderer;
var gfx;
var Material;

const CircleShader = require('CircleShader');

function CircleMaterial() {
	Material.call(this, false);

	var pass = new renderer.Pass('circle');
	pass.setDepth(false, false);
	pass.setCullMode(gfx.CULL_NONE);
	pass.setBlend(
		gfx.BLEND_FUNC_ADD,
		gfx.BLEND_SRC_ALPHA, gfx.BLEND_ONE_MINUS_SRC_ALPHA,
		gfx.BLEND_FUNC_ADD,
		gfx.BLEND_SRC_ALPHA, gfx.BLEND_ONE_MINUS_SRC_ALPHA
		);
	let mainTech = new renderer.Technique(
		['transparent'],
		[
			{name : 'texture', type : renderer.PARAM_TEXTURE_2D},
		],
		[
			pass
		]);

	this._texture = null;
	this._effect = this.effect = new renderer.Effect(
		[mainTech],
		{},
		[]);
	this._mainTech = mainTech;
}

cc.game.once(cc.game.EVENT_ENGINE_INITED, function() {
	renderEngine = cc.renderer.renderEngine;
	renderer = renderEngine.renderer;
	gfx = renderEngine.gfx;
	Material = renderEngine.Material;

	cc.js.extend(CircleMaterial, Material);
	cc.js.mixin(CircleMaterial.prototype, {
		getTexture : function() {
			return this._texture;
		},

		setTexture : function(val) {
			if(this._texture !== val) {
				this._texture = val;
				this.effect.setProperty('texture', val.getImpl());
			}
		}
	});
});

module.exports = CircleMaterial;