let shader = {
	name : 'circle',

	defines : [
	],

	vert : 
	`
		uniform mat4 viewProj;
		attribute vec4 a_position;
		attribute vec2 a_uv0;
		varying vec2 uv0;

		void main() {
			gl_Position = viewProj * a_position;
			uv0 = a_uv0;
		}
	`,
	frag : 
	`
		uniform sampler2D texture;
		varying vec2 uv0;
		void main() {
			float r = distance(uv0, vec2(0.5, 0.5));
			float a = 1.0 - smoothstep(0.5 - 0.01, 0.5 + 0.01, r);
			vec3 color = texture2D(texture, uv0).rgb;
			gl_FragColor = vec4(color, a);
		}
	`
};
/**
 * 引擎初始化完毕后，将shader脚本缓存起来
 */
cc.game.once(cc.game.EVENT_ENGINE_INITED, function() {
	cc.renderer._forward._programLib.define(shader.name, shader.vert, shader.frag, shader.defines);
});

module.exports = shader;